<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/ocu_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv3_p0 { color: #ff8bff; }
.textRainbow_lv2_p0 { color: #e0ffff; }
.textRainbow_lv1_o0 { color: #ffffe0; }
.textRainbow_lv2_o0 { color: #e0ffff; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>08/07/86  ocu_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>The ocu_ subroutine allows generation of  standard  format object
<span id="L5" class="LineNr">  5 </span>segments and multi-segment files.  The information is emitted via
<span id="L6" class="LineNr">  6 </span>calls to ocu_ entrypoints and stored in internal tables until the
<span id="L7" class="LineNr">  7 </span>invocation is closed, at which time the object is created and the
<span id="L8" class="LineNr">  8 </span>sections assembled and linked together properly.
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>Entry points in ocu_:
<span id="L12" class="LineNr"> 12 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>:Entry:  backpatch:  02/10/86 ocu_$backpatch
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>Function:
<span id="L19" class="LineNr"> 19 </span>     It is often  necessary in the creation of  an object segment
<span id="L20" class="LineNr"> 20 </span>     to  generate a  reference to  something which  has not  been
<span id="L21" class="LineNr"> 21 </span>     emitted yet.  This entrypoint allows changes to be made in a
<span id="L22" class="LineNr"> 22 </span>     word which has already been emitted.  Since many sections of
<span id="L23" class="LineNr"> 23 </span>     the object segment are being  synthesized by ocu_ from other
<span id="L24" class="LineNr"> 24 </span>     information, it  is not practical to patch  them.  <span class="textRainbow_lv0_p0">(</span>eg.  the
<span id="L25" class="LineNr"> 25 </span>     definition  section  contains  type_pairs<span class="textRainbow_lv0_o0">,</span> expression_words<span class="textRainbow_lv0_o0">,</span>
<span id="L26" class="LineNr"> 26 </span>     init_info<span class="textRainbow_lv0_o0">,</span> and  ACC_strings generated as byproducts  of link
<span id="L27" class="LineNr"> 27 </span>     generation.  The offsets of these  items are not known until
<span id="L28" class="LineNr"> 28 </span>     the object is closed.<span class="textRainbow_lv0_p0">)</span>  This entry is primarily for patching
<span id="L29" class="LineNr"> 29 </span>     sections which were emitted as blocks of words.  <span class="textRainbow_lv0_p0">(</span>ie.  text<span class="textRainbow_lv0_o0">,</span>
<span id="L30" class="LineNr"> 30 </span>     static<span class="textRainbow_lv0_o0">,</span> and symbol sections.<span class="textRainbow_lv0_p0">)</span>
<span id="L31" class="LineNr"> 31 </span>
<span id="L32" class="LineNr"> 32 </span>
<span id="L33" class="LineNr"> 33 </span>Syntax:
<span id="L34" class="LineNr"> 34 </span>  dcl ocu_$backpatch entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L35" class="LineNr"> 35 </span>          fixed bin <span class="textRainbow_lv1_p0">(</span>18<span class="textRainbow_lv1_p0">)</span> unsigned<span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span>;
<span id="L36" class="LineNr"> 36 </span>  call ocu_$backpatch <span class="textRainbow_lv1_p0">(</span>ocu_datap<span class="textRainbow_lv1_o0">,</span> section<span class="textRainbow_lv1_o0">,</span> offset<span class="textRainbow_lv1_o0">,</span> side<span class="textRainbow_lv1_o0">,</span>
<span id="L37" class="LineNr"> 37 </span>          new_value<span class="textRainbow_lv1_p0">)</span>;
<span id="L38" class="LineNr"> 38 </span>
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>Arguments:
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>ocu_datap
<span id="L43" class="LineNr"> 43 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L44" class="LineNr"> 44 </span>     data structures needed to create the object segment. <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>section
<span id="L47" class="LineNr"> 47 </span>     is  a  character  identifying  the  section  to  be patched.
<span id="L48" class="LineNr"> 48 </span>     <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L49" class="LineNr"> 49 </span>     Valid values for this argument are:
<span id="L50" class="LineNr"> 50 </span>     &quot;text&quot;   - to patch the text section.
<span id="L51" class="LineNr"> 51 </span>     &quot;static&quot; - to patch the static section.
<span id="L52" class="LineNr"> 52 </span>     &quot;symbol&quot; - to patch the symbol section.
<span id="L53" class="LineNr"> 53 </span>
<span id="L54" class="LineNr"> 54 </span>
<span id="L55" class="LineNr"> 55 </span>offset
<span id="L56" class="LineNr"> 56 </span>     is the word offset within  the given section of the halfword
<span id="L57" class="LineNr"> 57 </span>     to be patched.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>side
<span id="L60" class="LineNr"> 60 </span>     is a string indicating what portion of the specified word is
<span id="L61" class="LineNr"> 61 </span>     to be patched.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L62" class="LineNr"> 62 </span>     Valid  values  depend  on  the  section  being  patched  and
<span id="L63" class="LineNr"> 63 </span>     correspond to the valid types of relocation allowed for that
<span id="L64" class="LineNr"> 64 </span>     section.
<span id="L65" class="LineNr"> 65 </span>
<span id="L66" class="LineNr"> 66 </span>        - Text section
<span id="L67" class="LineNr"> 67 </span>               &quot;left 15 unsigned&quot;
<span id="L68" class="LineNr"> 68 </span>               &quot;left 15 signed&quot;
<span id="L69" class="LineNr"> 69 </span>               &quot;left 18 unsigned&quot;
<span id="L70" class="LineNr"> 70 </span>               &quot;left 18 signed&quot;
<span id="L71" class="LineNr"> 71 </span>               &quot;right 18 unsigned&quot;
<span id="L72" class="LineNr"> 72 </span>               &quot;right 18 unsigned&quot;
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span>          - Static section
<span id="L76" class="LineNr"> 76 </span>               &quot;left 18 unsigned&quot;
<span id="L77" class="LineNr"> 77 </span>               &quot;left 18 signed&quot;
<span id="L78" class="LineNr"> 78 </span>               &quot;right 18 unsigned&quot;
<span id="L79" class="LineNr"> 79 </span>               &quot;right 18 signed&quot;
<span id="L80" class="LineNr"> 80 </span>          - Symbol section
<span id="L81" class="LineNr"> 81 </span>               &quot;left 18 unsigned&quot;
<span id="L82" class="LineNr"> 82 </span>               &quot;left 18 signed&quot;
<span id="L83" class="LineNr"> 83 </span>               &quot;right 18 unsigned&quot;
<span id="L84" class="LineNr"> 84 </span>               &quot;right 18 signed&quot;
<span id="L85" class="LineNr"> 85 </span>
<span id="L86" class="LineNr"> 86 </span>
<span id="L87" class="LineNr"> 87 </span>new_value
<span id="L88" class="LineNr"> 88 </span>     is the new value to be patched into the specified portion of
<span id="L89" class="LineNr"> 89 </span>     the word.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>:Entry:  close:  02/10/86 ocu_$close
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>
<span id="L95" class="LineNr"> 95 </span>Function:
<span id="L96" class="LineNr"> 96 </span>     takes the information provided by previous calls to ocu_ and
<span id="L97" class="LineNr"> 97 </span>     assembles   the  final   object  segment.    The  relocation
<span id="L98" class="LineNr"> 98 </span>     information<span class="textRainbow_lv0_o0">,</span>  object_map<span class="textRainbow_lv0_o0">,</span> linkage header<span class="textRainbow_lv0_o0">,</span>  definition string
<span id="L99" class="LineNr"> 99 </span>     map<span class="textRainbow_lv0_o0">,</span> hash table<span class="textRainbow_lv0_o0">,</span> and header are synthesized at this point.
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>Syntax:
<span id="L103" class="LineNr">103 </span>  dcl ocu_$close entry <span class="textRainbow_lv1_p0">(</span>ptr<span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>35<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_p0">)</span>;
<span id="L104" class="LineNr">104 </span>  call ocu_$close <span class="textRainbow_lv1_p0">(</span>ocu_datap<span class="textRainbow_lv1_o0">,</span> code<span class="textRainbow_lv1_p0">)</span>;
<span id="L105" class="LineNr">105 </span>
<span id="L106" class="LineNr">106 </span>
<span id="L107" class="LineNr">107 </span>Arguments:
<span id="L108" class="LineNr">108 </span>
<span id="L109" class="LineNr">109 </span>ocu_datap
<span id="L110" class="LineNr">110 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L111" class="LineNr">111 </span>     data structures needed to create the object segment. <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L112" class="LineNr">112 </span>
<span id="L113" class="LineNr">113 </span>code
<span id="L114" class="LineNr">114 </span>     is a standard status code.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>:Entry:  create_msf:  08/07/86 ocu_$create_msf
<span id="L118" class="LineNr">118 </span>
<span id="L119" class="LineNr">119 </span>
<span id="L120" class="LineNr">120 </span>Function:
<span id="L121" class="LineNr">121 </span>     Creates component  0  of  an  object MSF.  Given an array of
<span id="L122" class="LineNr">122 </span>     pointers  to  all  of  the  components  of  a MSF <span class="textRainbow_lv1_p0">(</span>excepting
<span id="L123" class="LineNr">123 </span>     component  0<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>  generates component 0<span class="textRainbow_lv0_o0">,</span>  copying the external
<span id="L124" class="LineNr">124 </span>     definitions<span class="textRainbow_lv0_o0">,</span> and building the first reference trap.
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>
<span id="L127" class="LineNr">127 </span>Syntax:
<span id="L128" class="LineNr">128 </span>  dcl ocu_$create_msf entry <span class="textRainbow_lv1_p0">(</span>ptr<span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>15<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_o0">,</span>
<span id="L129" class="LineNr">129 </span>          ptr<span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>35<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_p0">)</span>;
<span id="L130" class="LineNr">130 </span>  call ocu_$create_msf <span class="textRainbow_lv1_p0">(</span>component_listp<span class="textRainbow_lv1_o0">,</span> component_count<span class="textRainbow_lv1_o0">,</span>
<span id="L131" class="LineNr">131 </span>          gen_infop<span class="textRainbow_lv1_o0">,</span> code<span class="textRainbow_lv1_p0">)</span>;
<span id="L132" class="LineNr">132 </span>
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>Arguments:
<span id="L135" class="LineNr">135 </span>
<span id="L136" class="LineNr">136 </span>component_listp
<span id="L137" class="LineNr">137 </span>     is  a   pointer  to  an  array  of   pointers  of  dimension
<span id="L138" class="LineNr">138 </span>     <span class="textRainbow_lv1_p0">(</span>1:component_count-1<span class="textRainbow_lv1_p0">)</span>.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L139" class="LineNr">139 </span>     Each pointer  points to one  component of the  MSF.  Each of
<span id="L140" class="LineNr">140 </span>     the pointers  points to a  completed object segment.   It is
<span id="L141" class="LineNr">141 </span>     assumed that each of the components already has it's linkage
<span id="L142" class="LineNr">142 </span>     section  built   as  a  MSF  <span class="textRainbow_lv1_p0">(</span>ie.    containing  appropriate
<span id="L143" class="LineNr">143 </span>     partially-snapped links<span class="textRainbow_lv1_p0">)</span> and that  the msf_map is present in
<span id="L144" class="LineNr">144 </span>     the definition section.
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>component_count
<span id="L147" class="LineNr">147 </span>     is the  number of components  in the final  MSF not counting
<span id="L148" class="LineNr">148 </span>     component 0.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L149" class="LineNr">149 </span>
<span id="L150" class="LineNr">150 </span>
<span id="L151" class="LineNr">151 </span>gen_infop
<span id="L152" class="LineNr">152 </span>     is  a pointer  to the   gen_info structure  used to  set the
<span id="L153" class="LineNr">153 </span>     generator_info in the symbol header of component 0.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L154" class="LineNr">154 </span>     The  gen_info  structure  is  declared  in  the include file
<span id="L155" class="LineNr">155 </span>     ocu_dcls.incl.pl1.
<span id="L156" class="LineNr">156 </span>
<span id="L157" class="LineNr">157 </span>       dcl 01 gen_info             aligned based<span class="textRainbow_lv0_o0">,</span>
<span id="L158" class="LineNr">158 </span>            02 gen_created         fixed bin <span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L159" class="LineNr">159 </span>            02 generator           char <span class="textRainbow_lv1_p0">(</span>8<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L160" class="LineNr">160 </span>            02 gen_number          fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L161" class="LineNr">161 </span>            02 gen_version         char <span class="textRainbow_lv1_p0">(</span>512<span class="textRainbow_lv1_p0">)</span> varying;
<span id="L162" class="LineNr">162 </span>
<span id="L163" class="LineNr">163 </span>
<span id="L164" class="LineNr">164 </span>     gen_created
<span id="L165" class="LineNr">165 </span>          is the clock time that the generator was created.
<span id="L166" class="LineNr">166 </span>
<span id="L167" class="LineNr">167 </span>     generator
<span id="L168" class="LineNr">168 </span>          is the name of the generator <span class="textRainbow_lv1_p0">(</span>eg.  PL/I<span class="textRainbow_lv1_o0">,</span> binder<span class="textRainbow_lv1_o0">,</span> etc.<span class="textRainbow_lv1_p0">)</span>.
<span id="L169" class="LineNr">169 </span>
<span id="L170" class="LineNr">170 </span>     gen_number
<span id="L171" class="LineNr">171 </span>          is  the version  number of  the generator.   This value
<span id="L172" class="LineNr">172 </span>          must the version number if the gen_version string.
<span id="L173" class="LineNr">173 </span>
<span id="L174" class="LineNr">174 </span>
<span id="L175" class="LineNr">175 </span>     gen_version
<span id="L176" class="LineNr">176 </span>          is a version string giving  the name<span class="textRainbow_lv0_o0">,</span> version<span class="textRainbow_lv0_o0">,</span> and date
<span id="L177" class="LineNr">177 </span>          of the  generator <span class="textRainbow_lv1_p0">(</span>eg.  Multics PL/I  Compiler<span class="textRainbow_lv1_o0">,</span> Release
<span id="L178" class="LineNr">178 </span>          28e<span class="textRainbow_lv1_o0">,</span> of February 14<span class="textRainbow_lv1_o0">,</span> 1985<span class="textRainbow_lv1_p0">)</span>
<span id="L179" class="LineNr">179 </span>
<span id="L180" class="LineNr">180 </span>code
<span id="L181" class="LineNr">181 </span>     is a standard status code.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
<span id="L182" class="LineNr">182 </span>
<span id="L183" class="LineNr">183 </span>
<span id="L184" class="LineNr">184 </span>:Entry:  emit_definition:  02/10/86 ocu_$emit_definition
<span id="L185" class="LineNr">185 </span>
<span id="L186" class="LineNr">186 </span>
<span id="L187" class="LineNr">187 </span>Function:
<span id="L188" class="LineNr">188 </span>     Emits a  single non-class-3 definition<span class="textRainbow_lv0_o0">,</span> and  threads it into
<span id="L189" class="LineNr">189 </span>     the definition list.  Definitions  are threaded in the order
<span id="L190" class="LineNr">190 </span>     of the calls  to ocu_$emit_definition and ocu_$emit_segname.
<span id="L191" class="LineNr">191 </span>     Successive calls to  emit_segname generate multiple segnames
<span id="L192" class="LineNr">192 </span>     in a  single block.  Calls to  emit_segname with intervening
<span id="L193" class="LineNr">193 </span>     calls to emit_definition create a new block.
<span id="L194" class="LineNr">194 </span>
<span id="L195" class="LineNr">195 </span>
<span id="L196" class="LineNr">196 </span>Syntax:
<span id="L197" class="LineNr">197 </span>  dcl ocu_$emit_definition entry <span class="textRainbow_lv1_p0">(</span>ptr<span class="textRainbow_lv1_o0">,</span> char <span class="textRainbow_lv2_p0">(</span>*<span class="textRainbow_lv2_p0">)</span> varying<span class="textRainbow_lv1_o0">,</span>
<span id="L198" class="LineNr">198 </span>          fixed bin <span class="textRainbow_lv2_p0">(</span>3<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_o0">,</span>
<span id="L199" class="LineNr">199 </span>          bit <span class="textRainbow_lv2_p0">(</span>*<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_p0">)</span> returns <span class="textRainbow_lv1_p0">(</span>fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_p0">)</span>;
<span id="L200" class="LineNr">200 </span>  def_relp = ocu_$emit_definition <span class="textRainbow_lv1_p0">(</span>ocu_datap<span class="textRainbow_lv1_o0">,</span> name<span class="textRainbow_lv1_o0">,</span> section<span class="textRainbow_lv1_o0">,</span>
<span id="L201" class="LineNr">201 </span>          offset<span class="textRainbow_lv1_o0">,</span> flags<span class="textRainbow_lv1_p0">)</span>;
<span id="L202" class="LineNr">202 </span>
<span id="L203" class="LineNr">203 </span>
<span id="L204" class="LineNr">204 </span>Arguments:
<span id="L205" class="LineNr">205 </span>
<span id="L206" class="LineNr">206 </span>ocu_datap
<span id="L207" class="LineNr">207 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L208" class="LineNr">208 </span>     data structures needed to create the object segment. <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L209" class="LineNr">209 </span>
<span id="L210" class="LineNr">210 </span>name
<span id="L211" class="LineNr">211 </span>     is the name of the definition.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L212" class="LineNr">212 </span>
<span id="L213" class="LineNr">213 </span>
<span id="L214" class="LineNr">214 </span>section
<span id="L215" class="LineNr">215 </span>     is the section that the definition refers to.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L216" class="LineNr">216 </span>     Constants    for   the    sections   can    be   found    in
<span id="L217" class="LineNr">217 </span>     definition_dcls.incl.pl1.     Valid   sections    for   this
<span id="L218" class="LineNr">218 </span>     subroutine are:
<span id="L219" class="LineNr">219 </span>
<span id="L220" class="LineNr">220 </span>          SECTION_TEXT   = 0
<span id="L221" class="LineNr">221 </span>          SECTION_LINK   = 1
<span id="L222" class="LineNr">222 </span>          SECTION_SYMBOL = 2
<span id="L223" class="LineNr">223 </span>          SECTION_STATIC = 4
<span id="L224" class="LineNr">224 </span>
<span id="L225" class="LineNr">225 </span>offset
<span id="L226" class="LineNr">226 </span>     is  the offset of  the target of  the definition within  the
<span id="L227" class="LineNr">227 </span>     given section.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L228" class="LineNr">228 </span>
<span id="L229" class="LineNr">229 </span>
<span id="L230" class="LineNr">230 </span>flags
<span id="L231" class="LineNr">231 </span>     is  a bit  string representing  the flags  to be  set in the
<span id="L232" class="LineNr">232 </span>     definition.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L233" class="LineNr">233 </span>     Constants   definition   the   values   can   be   found  in
<span id="L234" class="LineNr">234 </span>     ocu_dcls.incl.pl1.
<span id="L235" class="LineNr">235 </span>
<span id="L236" class="LineNr">236 </span>          DEFINITION_FLAGS_IGNORE   = &quot;1000&quot;b
<span id="L237" class="LineNr">237 </span>          DEFINITION_FLAGS_ENTRY    = &quot;0100&quot;b
<span id="L238" class="LineNr">238 </span>          DEFINITION_FLAGS_RETAIN   = &quot;0010&quot;b
<span id="L239" class="LineNr">239 </span>          DEFINITION_FLAGS_INDIRECT = &quot;0001&quot;b
<span id="L240" class="LineNr">240 </span>
<span id="L241" class="LineNr">241 </span>def_relp
<span id="L242" class="LineNr">242 </span>     is  an offset  to the  generated definition  relative to the
<span id="L243" class="LineNr">243 </span>     base of the definition section.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
<span id="L244" class="LineNr">244 </span>
<span id="L245" class="LineNr">245 </span>
<span id="L246" class="LineNr">246 </span>:Entry:  emit_firstref_trap:  02/10/86 ocu_$emit_firstref_trap
<span id="L247" class="LineNr">247 </span>
<span id="L248" class="LineNr">248 </span>
<span id="L249" class="LineNr">249 </span>Function:
<span id="L250" class="LineNr">250 </span>     Adds a  firstref trap to  the first reference  trap block in
<span id="L251" class="LineNr">251 </span>     the linkage  section.  The links reference  by the call_relp
<span id="L252" class="LineNr">252 </span>     and  info_relp  must  have  already  been  emitted.   Errors
<span id="L253" class="LineNr">253 </span>     encountered are reported using the sub_err_ subroutine.
<span id="L254" class="LineNr">254 </span>
<span id="L255" class="LineNr">255 </span>
<span id="L256" class="LineNr">256 </span>Syntax:
<span id="L257" class="LineNr">257 </span>  dcl ocu_$emit_firstref_trap entry <span class="textRainbow_lv1_p0">(</span>ptr<span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_o0">,</span>
<span id="L258" class="LineNr">258 </span>          fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_p0">)</span>;
<span id="L259" class="LineNr">259 </span>  call ocu_$emit_firstref_trap <span class="textRainbow_lv1_p0">(</span>ocu_datap<span class="textRainbow_lv1_o0">,</span> call_relp<span class="textRainbow_lv1_o0">,</span> info_relp<span class="textRainbow_lv1_p0">)</span>;
<span id="L260" class="LineNr">260 </span>
<span id="L261" class="LineNr">261 </span>
<span id="L262" class="LineNr">262 </span>Arguments:
<span id="L263" class="LineNr">263 </span>
<span id="L264" class="LineNr">264 </span>ocu_datap
<span id="L265" class="LineNr">265 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L266" class="LineNr">266 </span>     data structures needed to create the object segment. <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L267" class="LineNr">267 </span>
<span id="L268" class="LineNr">268 </span>call_relp
<span id="L269" class="LineNr">269 </span>     is the offset relative to the base of the linkage section of
<span id="L270" class="LineNr">270 </span>     a link to be used to call the trap procedure.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L271" class="LineNr">271 </span>
<span id="L272" class="LineNr">272 </span>info_relp
<span id="L273" class="LineNr">273 </span>     is the offset relative to the base of the linkage section of
<span id="L274" class="LineNr">274 </span>     a link to be passed to the trap procedure.  If this value is
<span id="L275" class="LineNr">275 </span>     0<span class="textRainbow_lv0_o0">,</span>  no  parameter  will  be  passed  to  the trap procedure.
<span id="L276" class="LineNr">276 </span>     <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L277" class="LineNr">277 </span>
<span id="L278" class="LineNr">278 </span>
<span id="L279" class="LineNr">279 </span>:Entry:  emit_link:  02/10/86 ocu_$emit_link
<span id="L280" class="LineNr">280 </span>
<span id="L281" class="LineNr">281 </span>
<span id="L282" class="LineNr">282 </span>Function:
<span id="L283" class="LineNr">283 </span>     Creates  a  single  external  link.   The  expression  word<span class="textRainbow_lv0_o0">,</span>
<span id="L284" class="LineNr">284 </span>     type_pair<span class="textRainbow_lv0_o0">,</span>   segname  and    offsetname  strings<span class="textRainbow_lv0_o0">,</span>   and  any
<span id="L285" class="LineNr">285 </span>     trap_words  or external   initialization information  in the
<span id="L286" class="LineNr">286 </span>     definition section  are also generated as  required.  Errors
<span id="L287" class="LineNr">287 </span>     encountered are reported using the sub_err_ subroutine.
<span id="L288" class="LineNr">288 </span>
<span id="L289" class="LineNr">289 </span>
<span id="L290" class="LineNr">290 </span>Syntax:
<span id="L291" class="LineNr">291 </span>  dcl ocu_$emit_link entry <span class="textRainbow_lv1_p0">(</span>ptr<span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>3<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>3<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span>
<span id="L292" class="LineNr">292 </span>          char <span class="textRainbow_lv2_p0">(</span>*<span class="textRainbow_lv2_p0">)</span> var<span class="textRainbow_lv1_o0">,</span> char <span class="textRainbow_lv2_p0">(</span>*<span class="textRainbow_lv2_p0">)</span> var<span class="textRainbow_lv1_o0">,</span> fixed bin<span class="textRainbow_lv1_o0">,</span> bit <span class="textRainbow_lv2_p0">(</span>6<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> ptr<span class="textRainbow_lv1_p0">)</span>
<span id="L293" class="LineNr">293 </span>          returns <span class="textRainbow_lv1_p0">(</span>fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_p0">)</span>;
<span id="L294" class="LineNr">294 </span>  link_relp = ocu_$emit_link <span class="textRainbow_lv1_p0">(</span>ocu_datap<span class="textRainbow_lv1_o0">,</span> type<span class="textRainbow_lv1_o0">,</span> class<span class="textRainbow_lv1_o0">,</span> segname<span class="textRainbow_lv1_o0">,</span>
<span id="L295" class="LineNr">295 </span>          offsetname<span class="textRainbow_lv1_o0">,</span> expression<span class="textRainbow_lv1_o0">,</span> modifier<span class="textRainbow_lv1_o0">,</span> init_infop<span class="textRainbow_lv1_p0">)</span>;
<span id="L296" class="LineNr">296 </span>
<span id="L297" class="LineNr">297 </span>
<span id="L298" class="LineNr">298 </span>Arguments:
<span id="L299" class="LineNr">299 </span>
<span id="L300" class="LineNr">300 </span>ocu_datap
<span id="L301" class="LineNr">301 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L302" class="LineNr">302 </span>     data structures needed to create the object segment. <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L303" class="LineNr">303 </span>
<span id="L304" class="LineNr">304 </span>type
<span id="L305" class="LineNr">305 </span>     is the type of the link.  Constants for the valid link types
<span id="L306" class="LineNr">306 </span>     can be found in definition_dcls.incl.pl1.  Valid valued are:
<span id="L307" class="LineNr">307 </span>
<span id="L308" class="LineNr">308 </span>          LINK_SELF_BASE          = 1
<span id="L309" class="LineNr">309 </span>          LINK_REFNAME_BASE       = 3
<span id="L310" class="LineNr">310 </span>          LINK_REFNAME_OFFSETNAME = 4
<span id="L311" class="LineNr">311 </span>          LINK_SELF_OFFSETNAME    = 5
<span id="L312" class="LineNr">312 </span>
<span id="L313" class="LineNr">313 </span>
<span id="L314" class="LineNr">314 </span>class
<span id="L315" class="LineNr">315 </span>     is the  class of the  link for type  1 <span class="textRainbow_lv1_p0">(</span>link self  base<span class="textRainbow_lv1_p0">)</span> and
<span id="L316" class="LineNr">316 </span>     type 5 <span class="textRainbow_lv1_p0">(</span>link self  offsetname<span class="textRainbow_lv1_p0">)</span>.  This indicates what section
<span id="L317" class="LineNr">317 </span>     of the  object segment the expression value  is relative to.
<span id="L318" class="LineNr">318 </span>     It is used only if the type is 1 or 5.  Constants usable for
<span id="L319" class="LineNr">319 </span>     this value are  declared in definition_dcls.incl.pl1.  Valid
<span id="L320" class="LineNr">320 </span>     values are:
<span id="L321" class="LineNr">321 </span>
<span id="L322" class="LineNr">322 </span>          CLASS_TEXT    = 0
<span id="L323" class="LineNr">323 </span>          CLASS_LINKAGE = 1
<span id="L324" class="LineNr">324 </span>          CLASS_SYMBOL  = 2
<span id="L325" class="LineNr">325 </span>          CLASS_STATIC  = 4
<span id="L326" class="LineNr">326 </span>          CLASS_SYSTEM  = 5
<span id="L327" class="LineNr">327 </span>          CLASS_HEAP    = 6
<span id="L328" class="LineNr">328 </span>
<span id="L329" class="LineNr">329 </span>
<span id="L330" class="LineNr">330 </span>segname
<span id="L331" class="LineNr">331 </span>     is the segname of the link  target.  This field is only used
<span id="L332" class="LineNr">332 </span>     if  the type of  the link is  type 3 <span class="textRainbow_lv1_p0">(</span>link-refname-base<span class="textRainbow_lv1_p0">)</span>  or
<span id="L333" class="LineNr">333 </span>     type 4 <span class="textRainbow_lv1_p0">(</span>link-refname-offsetname<span class="textRainbow_lv1_p0">)</span>.  This  is the refname that
<span id="L334" class="LineNr">334 </span>     will  be used  to search  for the  segment when  the link is
<span id="L335" class="LineNr">335 </span>     snapped.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L336" class="LineNr">336 </span>
<span id="L337" class="LineNr">337 </span>offsetname
<span id="L338" class="LineNr">338 </span>     is the  name of the definition  to be searched for  when the
<span id="L339" class="LineNr">339 </span>     link is snapped.   This field is only used if  the link type
<span id="L340" class="LineNr">340 </span>     is    type   4    <span class="textRainbow_lv1_p0">(</span>link-refname-offsetname<span class="textRainbow_lv1_p0">)</span>   or    type   5
<span id="L341" class="LineNr">341 </span>     <span class="textRainbow_lv1_p0">(</span>link-self-offsetname<span class="textRainbow_lv1_p0">)</span>.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L342" class="LineNr">342 </span>
<span id="L343" class="LineNr">343 </span>
<span id="L344" class="LineNr">344 </span>expression
<span id="L345" class="LineNr">345 </span>     is a word offset to be  added to the offset derived from the
<span id="L346" class="LineNr">346 </span>     section and offsetname values.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L347" class="LineNr">347 </span>
<span id="L348" class="LineNr">348 </span>modifier
<span id="L349" class="LineNr">349 </span>     is the modifier of the link.  This is the modifier that will
<span id="L350" class="LineNr">350 </span>     be  present in  the pointer  representing the  snapped link.
<span id="L351" class="LineNr">351 </span>     Generally a null modifier <span class="textRainbow_lv1_p0">(</span>&quot;&quot;b<span class="textRainbow_lv1_p0">)</span> is used.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L352" class="LineNr">352 </span>
<span id="L353" class="LineNr">353 </span>
<span id="L354" class="LineNr">354 </span>init_infop
<span id="L355" class="LineNr">355 </span>     is a pointer to the  initialization info<span class="textRainbow_lv0_o0">,</span> or to a trap_pair.
<span id="L356" class="LineNr">356 </span>     <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L357" class="LineNr">357 </span>     If the link is a type 5<span class="textRainbow_lv0_o0">,</span> class 5 link <span class="textRainbow_lv1_p0">(</span>a *system or external
<span id="L358" class="LineNr">358 </span>     link<span class="textRainbow_lv1_p0">)</span> or a type 5<span class="textRainbow_lv0_o0">,</span> class 6 link <span class="textRainbow_lv1_p0">(</span>a *heap link<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>  this points
<span id="L359" class="LineNr">359 </span>     to  an initialization info  block which  will be placed into
<span id="L360" class="LineNr">360 </span>     the  definition section.  This can  point  to  any  type  of
<span id="L361" class="LineNr">361 </span>     standard initialization  info <span class="textRainbow_lv1_p0">(</span>INIT_NO_INIT<span class="textRainbow_lv1_o0">,</span> INIT_COPY_INFO<span class="textRainbow_lv1_o0">,</span>
<span id="L362" class="LineNr">362 </span>     INIT_DEFINE_AREA<span class="textRainbow_lv1_o0">,</span>   INIT_LIST_TEMPLATE<span class="textRainbow_lv1_o0">,</span>  or INIT_DEFERRED if
<span id="L363" class="LineNr">363 </span>     the object segment being created is  an MSF  component.<span class="textRainbow_lv1_p0">)</span>  If
<span id="L364" class="LineNr">364 </span>     the link is not a *system  or *heap  link<span class="textRainbow_lv0_o0">,</span>  a non-null value
<span id="L365" class="LineNr">365 </span>     will  be assumed  to point  to a  trap-pair  representing  a
<span id="L366" class="LineNr">366 </span>     trap-before-link.   Since  trap-before-links  are  generally
<span id="L367" class="LineNr">367 </span>     obsolete<span class="textRainbow_lv0_o0">,</span>  this  should  only  be  non-null  when  supplying
<span id="L368" class="LineNr">368 </span>     initialization_info for *system or *heap links.
<span id="L369" class="LineNr">369 </span>
<span id="L370" class="LineNr">370 </span>
<span id="L371" class="LineNr">371 </span>link_relp
<span id="L372" class="LineNr">372 </span>     is  the offset  of this  link relative  to the  base of  the
<span id="L373" class="LineNr">373 </span>     linkage section.  Note that the  link offset returned is the
<span id="L374" class="LineNr">374 </span>     location of  the link assuming there  is no linkage-resident
<span id="L375" class="LineNr">375 </span>     static section.   When the object  is closed <span class="textRainbow_lv1_p0">(</span>via  a call to
<span id="L376" class="LineNr">376 </span>     ocu_$close<span class="textRainbow_lv1_p0">)</span> all link references will be relocated to account
<span id="L377" class="LineNr">377 </span>     for the  presence of a static  section.  If you plan  to use
<span id="L378" class="LineNr">378 </span>     this returned  link offset for purposes other  than to store
<span id="L379" class="LineNr">379 </span>     in one of the other object sections<span class="textRainbow_lv0_o0">,</span> you will have to adjust
<span id="L380" class="LineNr">380 </span>     for the static section manually.
<span id="L381" class="LineNr">381 </span>
<span id="L382" class="LineNr">382 </span>
<span id="L383" class="LineNr">383 </span>:Entry:  emit_partial_link:  02/10/86 ocu_$emit_partial_link
<span id="L384" class="LineNr">384 </span>
<span id="L385" class="LineNr">385 </span>
<span id="L386" class="LineNr">386 </span>Function:
<span id="L387" class="LineNr">387 </span>     Emits  an MSF partially snapped  link.  A  partially snapped
<span id="L388" class="LineNr">388 </span>     link uses  no information in the definition  section<span class="textRainbow_lv0_o0">,</span> and is
<span id="L389" class="LineNr">389 </span>     snapped  before  entry  by  a  first  reference  trap.  This
<span id="L390" class="LineNr">390 </span>     entrypoint  should  ONLY  be  called  when  generating a MSF
<span id="L391" class="LineNr">391 </span>     component.    Errors  are    reported  using   the  sub_err_
<span id="L392" class="LineNr">392 </span>     subroutine.
<span id="L393" class="LineNr">393 </span>
<span id="L394" class="LineNr">394 </span>
<span id="L395" class="LineNr">395 </span>Syntax:
<span id="L396" class="LineNr">396 </span>  dcl ocu_$emit_partial_link entry <span class="textRainbow_lv1_p0">(</span>ptr<span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>15<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_o0">,</span>
<span id="L397" class="LineNr">397 </span>          fixed bin <span class="textRainbow_lv2_p0">(</span>3<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_o0">,</span> bit <span class="textRainbow_lv2_p0">(</span>6<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_p0">)</span>
<span id="L398" class="LineNr">398 </span>          returns <span class="textRainbow_lv1_p0">(</span>fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_p0">)</span>;
<span id="L399" class="LineNr">399 </span>  link_relp = ocu_$emit_link <span class="textRainbow_lv1_p0">(</span>ocu_datap<span class="textRainbow_lv1_o0">,</span> component<span class="textRainbow_lv1_o0">,</span> section<span class="textRainbow_lv1_o0">,</span>
<span id="L400" class="LineNr">400 </span>          offset<span class="textRainbow_lv1_o0">,</span> modifier<span class="textRainbow_lv1_p0">)</span>;
<span id="L401" class="LineNr">401 </span>
<span id="L402" class="LineNr">402 </span>
<span id="L403" class="LineNr">403 </span>Arguments:
<span id="L404" class="LineNr">404 </span>
<span id="L405" class="LineNr">405 </span>ocu_datap
<span id="L406" class="LineNr">406 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L407" class="LineNr">407 </span>     data structures needed to create the object segment. <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L408" class="LineNr">408 </span>
<span id="L409" class="LineNr">409 </span>component
<span id="L410" class="LineNr">410 </span>     is the  component number of the target  component within the
<span id="L411" class="LineNr">411 </span>     MSF.  Generally this  will be in the range 1  to the maximum
<span id="L412" class="LineNr">412 </span>     component number.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L413" class="LineNr">413 </span>
<span id="L414" class="LineNr">414 </span>
<span id="L415" class="LineNr">415 </span>section
<span id="L416" class="LineNr">416 </span>     is  the target  section of  the link  within the  target MSF
<span id="L417" class="LineNr">417 </span>     component.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span> Constants for  these values can be found
<span id="L418" class="LineNr">418 </span>     in definition_dcls.incl.pl1.  Valid values are:
<span id="L419" class="LineNr">419 </span>
<span id="L420" class="LineNr">420 </span>          SECTION_TEXT    = 0
<span id="L421" class="LineNr">421 </span>          SECTION_LINKAGE = 1
<span id="L422" class="LineNr">422 </span>          SECTION_SYMBOL  = 2
<span id="L423" class="LineNr">423 </span>          SECTION_STATIC  = 4
<span id="L424" class="LineNr">424 </span>
<span id="L425" class="LineNr">425 </span>offset
<span id="L426" class="LineNr">426 </span>     is the offset of the pointer.  This value is relative to the
<span id="L427" class="LineNr">427 </span>     base  of the  section  specified  by the  section parameter.
<span id="L428" class="LineNr">428 </span>     <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L429" class="LineNr">429 </span>
<span id="L430" class="LineNr">430 </span>
<span id="L431" class="LineNr">431 </span>modifier
<span id="L432" class="LineNr">432 </span>     is the modifier of the link.  This will also be the modifier
<span id="L433" class="LineNr">433 </span>     of  the pointer  generated by  snapping the  link.  The null
<span id="L434" class="LineNr">434 </span>     modifier <span class="textRainbow_lv1_p0">(</span>&quot;&quot;b<span class="textRainbow_lv1_p0">)</span> is generally used.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L435" class="LineNr">435 </span>
<span id="L436" class="LineNr">436 </span>link_relp
<span id="L437" class="LineNr">437 </span>     is the offset of the generated  link relative to the base of
<span id="L438" class="LineNr">438 </span>     the linkage section.  Note that  this value is calculated as
<span id="L439" class="LineNr">439 </span>     if  there were  no static  section resident  in the  linkage
<span id="L440" class="LineNr">440 </span>     section.   When  the  object  is   closed  <span class="textRainbow_lv1_p0">(</span>via  a  call  to
<span id="L441" class="LineNr">441 </span>     ocu_$close<span class="textRainbow_lv1_p0">)</span> all  linkage references are relocated  to adjust
<span id="L442" class="LineNr">442 </span>     for the presence of a  static section.  If the caller wishes
<span id="L443" class="LineNr">443 </span>     to  use this  value for  other purposes  that to  include in
<span id="L444" class="LineNr">444 </span>     another call  to ocu_<span class="textRainbow_lv0_o0">,</span> it will  have to be adjusted  for the
<span id="L445" class="LineNr">445 </span>     presence of the static section manually.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
<span id="L446" class="LineNr">446 </span>
<span id="L447" class="LineNr">447 </span>
<span id="L448" class="LineNr">448 </span>:Entry:  emit_segname:  02/10/86 ocu_$emit_segname
<span id="L449" class="LineNr">449 </span>
<span id="L450" class="LineNr">450 </span>
<span id="L451" class="LineNr">451 </span>Function:
<span id="L452" class="LineNr">452 </span>     Emits a single class-3  <span class="textRainbow_lv1_p0">(</span>segname<span class="textRainbow_lv1_p0">)</span> definition<span class="textRainbow_lv0_o0">,</span> and threads it
<span id="L453" class="LineNr">453 </span>     into  the definition list.   The definitions are  chained in
<span id="L454" class="LineNr">454 </span>     the   order    of   calls   to    ocu_$emit_definition   and
<span id="L455" class="LineNr">455 </span>     ocu_$emit_segname.    Sequential   calls   to   emit_segname
<span id="L456" class="LineNr">456 </span>     generate  multiple segnames  in a  single block.   A call to
<span id="L457" class="LineNr">457 </span>     emit_segname  after calls  to emit_definition  starts a  new
<span id="L458" class="LineNr">458 </span>     block.   It  is  invalid  to  call  emit_definition  without
<span id="L459" class="LineNr">459 </span>     calling emit_segname at least once.
<span id="L460" class="LineNr">460 </span>
<span id="L461" class="LineNr">461 </span>
<span id="L462" class="LineNr">462 </span>Syntax:
<span id="L463" class="LineNr">463 </span>  dcl ocu_$emit_segname entry <span class="textRainbow_lv1_p0">(</span>ptr<span class="textRainbow_lv1_o0">,</span> char <span class="textRainbow_lv2_p0">(</span>*<span class="textRainbow_lv2_p0">)</span> varying<span class="textRainbow_lv1_o0">,</span> bit <span class="textRainbow_lv2_p0">(</span>*<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_p0">)</span>
<span id="L464" class="LineNr">464 </span>          returns <span class="textRainbow_lv1_p0">(</span>fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_p0">)</span>;
<span id="L465" class="LineNr">465 </span>  def_relp = ocu_$emit_segname <span class="textRainbow_lv1_p0">(</span>ocu_datap<span class="textRainbow_lv1_o0">,</span> name<span class="textRainbow_lv1_o0">,</span> flags<span class="textRainbow_lv1_p0">)</span>;
<span id="L466" class="LineNr">466 </span>
<span id="L467" class="LineNr">467 </span>
<span id="L468" class="LineNr">468 </span>Arguments:
<span id="L469" class="LineNr">469 </span>
<span id="L470" class="LineNr">470 </span>ocu_datap
<span id="L471" class="LineNr">471 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L472" class="LineNr">472 </span>     data structures needed to create the object segment. <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L473" class="LineNr">473 </span>
<span id="L474" class="LineNr">474 </span>name
<span id="L475" class="LineNr">475 </span>     is the name of this segname definition.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L476" class="LineNr">476 </span>
<span id="L477" class="LineNr">477 </span>
<span id="L478" class="LineNr">478 </span>flags
<span id="L479" class="LineNr">479 </span>     is  a bit  string representing  the flags  to be  set in the
<span id="L480" class="LineNr">480 </span>     definition.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L481" class="LineNr">481 </span>     Constants   definition   the   values   can   be   found  in
<span id="L482" class="LineNr">482 </span>     ocu_dcls.incl.pl1.
<span id="L483" class="LineNr">483 </span>
<span id="L484" class="LineNr">484 </span>          DEFINITION_FLAGS_IGNORE   = &quot;1000&quot;b
<span id="L485" class="LineNr">485 </span>          DEFINITION_FLAGS_ENTRY    = &quot;0100&quot;b
<span id="L486" class="LineNr">486 </span>          DEFINITION_FLAGS_RETAIN   = &quot;0010&quot;b
<span id="L487" class="LineNr">487 </span>          DEFINITION_FLAGS_INDIRECT = &quot;0001&quot;b
<span id="L488" class="LineNr">488 </span>
<span id="L489" class="LineNr">489 </span>def_relp
<span id="L490" class="LineNr">490 </span>     is  an offset  to the  generated definition  relative to the
<span id="L491" class="LineNr">491 </span>     base of the definition section.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
<span id="L492" class="LineNr">492 </span>
<span id="L493" class="LineNr">493 </span>
<span id="L494" class="LineNr">494 </span>:Entry:  emit_static:  02/10/86 ocu_$emit_static
<span id="L495" class="LineNr">495 </span>
<span id="L496" class="LineNr">496 </span>
<span id="L497" class="LineNr">497 </span>Function:
<span id="L498" class="LineNr">498 </span>     Emits  a block  of words  which are  appended to  the static
<span id="L499" class="LineNr">499 </span>     section.  Since  there is no relocation info  for the static
<span id="L500" class="LineNr">500 </span>     section <span class="textRainbow_lv1_p0">(</span>and it is forced to  be absolute if it is contained
<span id="L501" class="LineNr">501 </span>     in  the  linkage  section<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>  no  relocation  information  is
<span id="L502" class="LineNr">502 </span>     required.   Note that even  if the static  section is to  be
<span id="L503" class="LineNr">503 </span>     contained in  the linkage section<span class="textRainbow_lv0_o0">,</span> references  to the static
<span id="L504" class="LineNr">504 </span>     section should  be made with static relocation  info and not
<span id="L505" class="LineNr">505 </span>     attempt  to  adjust  the  offsets  for  the  presence of the
<span id="L506" class="LineNr">506 </span>     linkage header.   when the new object is  closed<span class="textRainbow_lv0_o0">,</span> all static
<span id="L507" class="LineNr">507 </span>     references  will  be  mapped  into  the  appropriate linkage
<span id="L508" class="LineNr">508 </span>     references.
<span id="L509" class="LineNr">509 </span>     Error   encountered   are   reported   using   the  sub_err_
<span id="L510" class="LineNr">510 </span>     subroutine.
<span id="L511" class="LineNr">511 </span>
<span id="L512" class="LineNr">512 </span>
<span id="L513" class="LineNr">513 </span>Syntax:
<span id="L514" class="LineNr">514 </span>  dcl ocu_$emit_static entry <span class="textRainbow_lv1_p0">(</span>ptr<span class="textRainbow_lv1_o0">,</span> ptr<span class="textRainbow_lv1_o0">,</span> fixed bin <span class="textRainbow_lv2_p0">(</span>18<span class="textRainbow_lv2_p0">)</span> unsigned<span class="textRainbow_lv1_o0">,</span>
<span id="L515" class="LineNr">515 </span>          returns <span class="textRainbow_lv2_p0">(</span>fixed bin <span class="textRainbow_lv3_p0">(</span>18<span class="textRainbow_lv3_p0">)</span> unsigned<span class="textRainbow_lv2_p0">)</span>;
<span id="L516" class="LineNr">516 </span>  static_relp = ocu_$emit_static <span class="textRainbow_lv2_p0">(</span>ocu_datap<span class="textRainbow_lv2_o0">,</span> staticp<span class="textRainbow_lv2_o0">,</span> word_count<span class="textRainbow_lv2_p0">)</span>;
<span id="L517" class="LineNr">517 </span>
<span id="L518" class="LineNr">518 </span>
<span id="L519" class="LineNr">519 </span>Arguments:
<span id="L520" class="LineNr">520 </span>
<span id="L521" class="LineNr">521 </span>ocu_datap
<span id="L522" class="LineNr">522 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L523" class="LineNr">523 </span>     data structures needed to create the object segment. <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L524" class="LineNr">524 </span>
<span id="L525" class="LineNr">525 </span>staticp
<span id="L526" class="LineNr">526 </span>     is a pointer to an  array or words of dimension <span class="textRainbow_lv2_p0">(</span>word_count<span class="textRainbow_lv2_p0">)</span>
<span id="L527" class="LineNr">527 </span>     to be appended to the static section.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L528" class="LineNr">528 </span>
<span id="L529" class="LineNr">529 </span>
<span id="L530" class="LineNr">530 </span>word_count
<span id="L531" class="LineNr">531 </span>     is the number of words to be appended to the static section.
<span id="L532" class="LineNr">532 </span>     <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L533" class="LineNr">533 </span>
<span id="L534" class="LineNr">534 </span>static_relp
<span id="L535" class="LineNr">535 </span>     is the offset of the block  or words relative to the base of
<span id="L536" class="LineNr">536 </span>     the static section
<span id="L537" class="LineNr">537 </span>
<span id="L538" class="LineNr">538 </span>
<span id="L539" class="LineNr">539 </span>:Entry:  emit_symbol:  02/10/86 ocu_$emit_symbol
<span id="L540" class="LineNr">540 </span>
<span id="L541" class="LineNr">541 </span>
<span id="L542" class="LineNr">542 </span>Function:
<span id="L543" class="LineNr">543 </span>     Emits a block of symbol words and appends them to the symbol
<span id="L544" class="LineNr">544 </span>     section.  Errors encountered are reported using the sub_err_
<span id="L545" class="LineNr">545 </span>     subroutine.
<span id="L546" class="LineNr">546 </span>
<span id="L547" class="LineNr">547 </span>
<span id="L548" class="LineNr">548 </span>Syntax:
<span id="L549" class="LineNr">549 </span>  dcl ocu_$emit_symbol entry <span class="textRainbow_lv2_p0">(</span>ptr<span class="textRainbow_lv2_o0">,</span> ptr<span class="textRainbow_lv2_o0">,</span> ptr<span class="textRainbow_lv2_o0">,</span>
<span id="L550" class="LineNr">550 </span>          fixed bin <span class="textRainbow_lv3_p0">(</span>18<span class="textRainbow_lv3_p0">)</span> unsigned<span class="textRainbow_lv2_p0">)</span>
<span id="L551" class="LineNr">551 </span>          returns <span class="textRainbow_lv2_p0">(</span>fixed bin <span class="textRainbow_lv3_p0">(</span>18<span class="textRainbow_lv3_p0">)</span> unsigned<span class="textRainbow_lv2_p0">)</span>;
<span id="L552" class="LineNr">552 </span>  symbol_relp = ocu_$emit_symbol <span class="textRainbow_lv2_p0">(</span>ocu_datap<span class="textRainbow_lv2_o0">,</span> symbolp<span class="textRainbow_lv2_o0">,</span>
<span id="L553" class="LineNr">553 </span>          relocationp<span class="textRainbow_lv2_o0">,</span> word_count<span class="textRainbow_lv2_p0">)</span>;
<span id="L554" class="LineNr">554 </span>
<span id="L555" class="LineNr">555 </span>
<span id="L556" class="LineNr">556 </span>Arguments:
<span id="L557" class="LineNr">557 </span>
<span id="L558" class="LineNr">558 </span>ocu_datap
<span id="L559" class="LineNr">559 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L560" class="LineNr">560 </span>     data structures needed to create the object segment. <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L561" class="LineNr">561 </span>
<span id="L562" class="LineNr">562 </span>symbolp
<span id="L563" class="LineNr">563 </span>     is a pointer  to an array symbol section  words of dimension
<span id="L564" class="LineNr">564 </span>     <span class="textRainbow_lv2_p0">(</span>word_count<span class="textRainbow_lv2_p0">)</span> to be appended to the symbol section.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L565" class="LineNr">565 </span>
<span id="L566" class="LineNr">566 </span>
<span id="L567" class="LineNr">567 </span>relocationp
<span id="L568" class="LineNr">568 </span>     is a pointer to a  character string of length <span class="textRainbow_lv2_p0">(</span>2*word_count<span class="textRainbow_lv2_p0">)</span>
<span id="L569" class="LineNr">569 </span>     representing the relocation information for the accompanying
<span id="L570" class="LineNr">570 </span>     block of words.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L571" class="LineNr">571 </span>     The relocation characters are taken from the set of standard
<span id="L572" class="LineNr">572 </span>     characters  used by  language translators  <span class="textRainbow_lv2_p0">(</span>see the  Multics
<span id="L573" class="LineNr">573 </span>     Programmers  Reference Manual<span class="textRainbow_lv2_p0">)</span>.    The relocation  string is
<span id="L574" class="LineNr">574 </span>     required  even  if  the  object   to  be  generated  is  not
<span id="L575" class="LineNr">575 </span>     relocatables  since the  relocation information  is used  to
<span id="L576" class="LineNr">576 </span>     locate static  and linkage references which will  have to be
<span id="L577" class="LineNr">577 </span>     relocated if the static section is linkage resident.
<span id="L578" class="LineNr">578 </span>
<span id="L579" class="LineNr">579 </span>word_count
<span id="L580" class="LineNr">580 </span>     is the number of symbol words to be emitted.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L581" class="LineNr">581 </span>
<span id="L582" class="LineNr">582 </span>symbol_relp
<span id="L583" class="LineNr">583 </span>     is the offset of this block of words relative to the base of
<span id="L584" class="LineNr">584 </span>     the symbol section.  <span class="textRainbow_lv2_p0">(</span>Output<span class="textRainbow_lv2_p0">)</span>
<span id="L585" class="LineNr">585 </span>
<span id="L586" class="LineNr">586 </span>
<span id="L587" class="LineNr">587 </span>:Entry:  emit_text:  02/10/86 ocu_$emit_text
<span id="L588" class="LineNr">588 </span>
<span id="L589" class="LineNr">589 </span>
<span id="L590" class="LineNr">590 </span>Function:
<span id="L591" class="LineNr">591 </span>     emits a  block of text words<span class="textRainbow_lv1_o0">,</span>  appending them to the  end of
<span id="L592" class="LineNr">592 </span>     the text  section and returning  the offset within  the text
<span id="L593" class="LineNr">593 </span>     section.  Errors encountered are reported using the sub_err_
<span id="L594" class="LineNr">594 </span>     subroutine.
<span id="L595" class="LineNr">595 </span>
<span id="L596" class="LineNr">596 </span>
<span id="L597" class="LineNr">597 </span>Syntax:
<span id="L598" class="LineNr">598 </span>  dcl ocu_$emit_text entry <span class="textRainbow_lv2_p0">(</span>ptr<span class="textRainbow_lv2_o0">,</span> ptr<span class="textRainbow_lv2_o0">,</span> ptr<span class="textRainbow_lv2_o0">,</span> fixed bin <span class="textRainbow_lv3_p0">(</span>18<span class="textRainbow_lv3_p0">)</span> unsigned<span class="textRainbow_lv2_p0">)</span>
<span id="L599" class="LineNr">599 </span>          returns <span class="textRainbow_lv2_p0">(</span>fixed bin <span class="textRainbow_lv3_p0">(</span>18<span class="textRainbow_lv3_p0">)</span> unsigned<span class="textRainbow_lv2_p0">)</span>;
<span id="L600" class="LineNr">600 </span>  text_relp = ocu_$emit_text <span class="textRainbow_lv2_p0">(</span>ocu_datap<span class="textRainbow_lv2_o0">,</span> textp<span class="textRainbow_lv2_o0">,</span> relocationp<span class="textRainbow_lv2_o0">,</span>
<span id="L601" class="LineNr">601 </span>          word_count<span class="textRainbow_lv2_p0">)</span>;
<span id="L602" class="LineNr">602 </span>
<span id="L603" class="LineNr">603 </span>
<span id="L604" class="LineNr">604 </span>Arguments:
<span id="L605" class="LineNr">605 </span>
<span id="L606" class="LineNr">606 </span>ocu_datap
<span id="L607" class="LineNr">607 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L608" class="LineNr">608 </span>     data structures needed to create the object segment. <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L609" class="LineNr">609 </span>
<span id="L610" class="LineNr">610 </span>textp
<span id="L611" class="LineNr">611 </span>     is  a  pointer  to  an  array  of  text  words  of dimension
<span id="L612" class="LineNr">612 </span>     <span class="textRainbow_lv2_p0">(</span>word_count<span class="textRainbow_lv2_p0">)</span> to be appended to the text section.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L613" class="LineNr">613 </span>
<span id="L614" class="LineNr">614 </span>
<span id="L615" class="LineNr">615 </span>relocationp
<span id="L616" class="LineNr">616 </span>     is a pointer to a  character string of length <span class="textRainbow_lv2_p0">(</span>2*word_count<span class="textRainbow_lv2_p0">)</span>
<span id="L617" class="LineNr">617 </span>     representing the relocation  information associated with the
<span id="L618" class="LineNr">618 </span>     text array.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L619" class="LineNr">619 </span>     The  characters used  are the  standard character relocation
<span id="L620" class="LineNr">620 </span>     codes used by the translators.  <span class="textRainbow_lv2_p0">(</span>see the Multics Programmers
<span id="L621" class="LineNr">621 </span>     Reference  Manual<span class="textRainbow_lv2_p0">)</span>.  This  string is  required regardless of
<span id="L622" class="LineNr">622 </span>     whether the output  object is to be relocatable  since it is
<span id="L623" class="LineNr">623 </span>     used to relocate linkage and static references if the static
<span id="L624" class="LineNr">624 </span>     section is not separate.
<span id="L625" class="LineNr">625 </span>
<span id="L626" class="LineNr">626 </span>word_count
<span id="L627" class="LineNr">627 </span>     is the number of words of text to be emitted.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L628" class="LineNr">628 </span>
<span id="L629" class="LineNr">629 </span>text_relp
<span id="L630" class="LineNr">630 </span>     is an offset to this block  of words relative to the base of
<span id="L631" class="LineNr">631 </span>     the section.  <span class="textRainbow_lv2_p0">(</span>Output<span class="textRainbow_lv2_p0">)</span>
<span id="L632" class="LineNr">632 </span>
<span id="L633" class="LineNr">633 </span>
<span id="L634" class="LineNr">634 </span>:Entry:  emit_msf_map:  08/07/86 ocu_$emit_msf_map
<span id="L635" class="LineNr">635 </span>
<span id="L636" class="LineNr">636 </span>
<span id="L637" class="LineNr">637 </span>Function:
<span id="L638" class="LineNr">638 </span>     Emits  the msf_map  in the   definition section  of the  new
<span id="L639" class="LineNr">639 </span>     object.  This entrypoint should ONLY be called if the object
<span id="L640" class="LineNr">640 </span>     segment  being   generated  is  an MSF   component.   Errors
<span id="L641" class="LineNr">641 </span>     encountered  are  reported  using   calls  to  the  sub_err_
<span id="L642" class="LineNr">642 </span>     subroutine.
<span id="L643" class="LineNr">643 </span>
<span id="L644" class="LineNr">644 </span>
<span id="L645" class="LineNr">645 </span>Syntax:
<span id="L646" class="LineNr">646 </span>  dcl ocu_$emit_msf_map <span class="textRainbow_lv2_p0">(</span>ptr<span class="textRainbow_lv2_o0">,</span> fixed bin <span class="textRainbow_lv3_p0">(</span>15<span class="textRainbow_lv3_p0">)</span> unsigned<span class="textRainbow_lv2_o0">,</span>
<span id="L647" class="LineNr">647 </span>          fixed bin <span class="textRainbow_lv3_p0">(</span>15<span class="textRainbow_lv3_p0">)</span> unsigned<span class="textRainbow_lv2_p0">)</span>;
<span id="L648" class="LineNr">648 </span>  call ocu_$emit_msf_map <span class="textRainbow_lv2_p0">(</span>ocu_datap<span class="textRainbow_lv2_o0">,</span> component_count<span class="textRainbow_lv2_o0">,</span>
<span id="L649" class="LineNr">649 </span>          my_component<span class="textRainbow_lv2_p0">)</span>;
<span id="L650" class="LineNr">650 </span>
<span id="L651" class="LineNr">651 </span>
<span id="L652" class="LineNr">652 </span>Arguments:
<span id="L653" class="LineNr">653 </span>
<span id="L654" class="LineNr">654 </span>ocu_datap
<span id="L655" class="LineNr">655 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L656" class="LineNr">656 </span>     data structures needed to create the object segment. <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L657" class="LineNr">657 </span>
<span id="L658" class="LineNr">658 </span>component_count
<span id="L659" class="LineNr">659 </span>     is the number of components  in the MSF<span class="textRainbow_lv1_o0">,</span> including component
<span id="L660" class="LineNr">660 </span>     0.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L661" class="LineNr">661 </span>
<span id="L662" class="LineNr">662 </span>my_component
<span id="L663" class="LineNr">663 </span>     is the number of the  component being generated in the range
<span id="L664" class="LineNr">664 </span>     0 to component_count - 1.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L665" class="LineNr">665 </span>
<span id="L666" class="LineNr">666 </span>
<span id="L667" class="LineNr">667 </span>:Entry:  open:  02/10/86 ocu_$open
<span id="L668" class="LineNr">668 </span>
<span id="L669" class="LineNr">669 </span>
<span id="L670" class="LineNr">670 </span>Function:
<span id="L671" class="LineNr">671 </span>     Allocates and initializes the data structures used to create
<span id="L672" class="LineNr">672 </span>     the object segment and returns  a pointer used to locate the
<span id="L673" class="LineNr">673 </span>     structures.
<span id="L674" class="LineNr">674 </span>
<span id="L675" class="LineNr">675 </span>
<span id="L676" class="LineNr">676 </span>Syntax:
<span id="L677" class="LineNr">677 </span>  dcl ocu_$open entry <span class="textRainbow_lv2_p0">(</span>char <span class="textRainbow_lv3_p0">(</span>*<span class="textRainbow_lv3_p0">)</span><span class="textRainbow_lv2_o0">,</span> char <span class="textRainbow_lv3_p0">(</span>*<span class="textRainbow_lv3_p0">)</span><span class="textRainbow_lv2_o0">,</span> bit <span class="textRainbow_lv3_p0">(</span>*<span class="textRainbow_lv3_p0">)</span><span class="textRainbow_lv2_o0">,</span> ptr<span class="textRainbow_lv2_o0">,</span>
<span id="L678" class="LineNr">678 </span>          fixed bin <span class="textRainbow_lv3_p0">(</span>35<span class="textRainbow_lv3_p0">)</span><span class="textRainbow_lv2_p0">)</span>;
<span id="L679" class="LineNr">679 </span>  call ocu_$open <span class="textRainbow_lv2_p0">(</span>dir_name<span class="textRainbow_lv2_o0">,</span> entry_name<span class="textRainbow_lv2_o0">,</span> flags<span class="textRainbow_lv2_o0">,</span> ocu_datap<span class="textRainbow_lv2_o0">,</span> code<span class="textRainbow_lv2_p0">)</span>;
<span id="L680" class="LineNr">680 </span>
<span id="L681" class="LineNr">681 </span>
<span id="L682" class="LineNr">682 </span>Arguments:
<span id="L683" class="LineNr">683 </span>
<span id="L684" class="LineNr">684 </span>dir_name
<span id="L685" class="LineNr">685 </span>     is the name of the directory  in which the final object will
<span id="L686" class="LineNr">686 </span>     be created.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L687" class="LineNr">687 </span>
<span id="L688" class="LineNr">688 </span>entry_name
<span id="L689" class="LineNr">689 </span>     is the entry name of the output object segment.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L690" class="LineNr">690 </span>
<span id="L691" class="LineNr">691 </span>
<span id="L692" class="LineNr">692 </span>flags
<span id="L693" class="LineNr">693 </span>     is a bit string indicating various options to be used in the
<span id="L694" class="LineNr">694 </span>     creation of the object segment.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
<span id="L695" class="LineNr">695 </span>     The following values may be  used to derive the desired flag
<span id="L696" class="LineNr">696 </span>     value.  <span class="textRainbow_lv2_p0">(</span>found in ocu_dcls.incl.pl1<span class="textRainbow_lv2_p0">)</span>
<span id="L697" class="LineNr">697 </span>
<span id="L698" class="LineNr">698 </span>
<span id="L699" class="LineNr">699 </span>          OPEN_FLAGS_BOUND             = &quot;100000&quot;b
<span id="L700" class="LineNr">700 </span>               The object being created will have the format of a
<span id="L701" class="LineNr">701 </span>               bound   object  <span class="textRainbow_lv2_p0">(</span>ie.    one  containing   multiple
<span id="L702" class="LineNr">702 </span>               translator  produced  objects<span class="textRainbow_lv2_p0">)</span>  and  is  formatted
<span id="L703" class="LineNr">703 </span>               according  to  the  standards  for  bound objects.
<span id="L704" class="LineNr">704 </span>               This format is not enforced  by ocu_ and it is the
<span id="L705" class="LineNr">705 </span>               responsibility of the caller  to set up the object
<span id="L706" class="LineNr">706 </span>               properly.
<span id="L707" class="LineNr">707 </span>
<span id="L708" class="LineNr">708 </span>
<span id="L709" class="LineNr">709 </span>          OPEN_FLAGS_RELOCATABLE       = &quot;010000&quot;b
<span id="L710" class="LineNr">710 </span>               The   object   being    created   has   relocation
<span id="L711" class="LineNr">711 </span>               information and can be used as input to the binder
<span id="L712" class="LineNr">712 </span>               or linkage  editor.  This flag is used  by ocu_ to
<span id="L713" class="LineNr">713 </span>               determine  whether or  not to  add the  relocation
<span id="L714" class="LineNr">714 </span>               information to  the linkage section of  the object
<span id="L715" class="LineNr">715 </span>               segment when the object is closed.
<span id="L716" class="LineNr">716 </span>
<span id="L717" class="LineNr">717 </span>
<span id="L718" class="LineNr">718 </span>          OPEN_FLAGS_PROCEDURE         = &quot;001000&quot;b
<span id="L719" class="LineNr">719 </span>               The object contains executable code.
<span id="L720" class="LineNr">720 </span>          OPEN_FLAGS_SEPARATE_STATIC   = &quot;000100&quot;b
<span id="L721" class="LineNr">721 </span>               The object segment is  to contain a static section
<span id="L722" class="LineNr">722 </span>               rather  than have  the static  section included in
<span id="L723" class="LineNr">723 </span>               the  linkage section.   This flag  is examined  by
<span id="L724" class="LineNr">724 </span>               ocu_ when closing the  object segment to determine
<span id="L725" class="LineNr">725 </span>               relocation   of   static   and   linkage   section
<span id="L726" class="LineNr">726 </span>               references and to generate the sections properly.
<span id="L727" class="LineNr">727 </span>
<span id="L728" class="LineNr">728 </span>
<span id="L729" class="LineNr">729 </span>          OPEN_FLAGS_PERPROCESS_STATIC = &quot;000010&quot;b
<span id="L730" class="LineNr">730 </span>               The static  section of this object  segment is not
<span id="L731" class="LineNr">731 </span>               to  be duplicated  when called  from within  a run
<span id="L732" class="LineNr">732 </span>               unit.
<span id="L733" class="LineNr">733 </span>          OPEN_FLAGS_NO_HASHTABLE      = &quot;000001&quot;b
<span id="L734" class="LineNr">734 </span>               Do not create a definition section  hash table for
<span id="L735" class="LineNr">735 </span>               this object segment.   This is primarily used when
<span id="L736" class="LineNr">736 </span>               creating either  MSF  components  <span class="textRainbow_lv2_p0">(</span>which are never
<span id="L737" class="LineNr">737 </span>               searched<span class="textRainbow_lv2_p0">)</span> or objects with very few entrypoints.
<span id="L738" class="LineNr">738 </span>
<span id="L739" class="LineNr">739 </span>
<span id="L740" class="LineNr">740 </span>ocu_datap
<span id="L741" class="LineNr">741 </span>     is a  pointer to the ocu  data structures used by  the other
<span id="L742" class="LineNr">742 </span>     calls.  <span class="textRainbow_lv2_p0">(</span>Output<span class="textRainbow_lv2_p0">)</span>
<span id="L743" class="LineNr">743 </span>
<span id="L744" class="LineNr">744 </span>code
<span id="L745" class="LineNr">745 </span>     is a standard status code.  <span class="textRainbow_lv2_p0">(</span>Output<span class="textRainbow_lv2_p0">)</span>
<span id="L746" class="LineNr">746 </span>
<span id="L747" class="LineNr">747 </span>
<span id="L748" class="LineNr">748 </span>:Entry:  release:  02/10/86 ocu_$release
<span id="L749" class="LineNr">749 </span>
<span id="L750" class="LineNr">750 </span>
<span id="L751" class="LineNr">751 </span>Function:
<span id="L752" class="LineNr">752 </span>     Releases table storage used by ocu_  when  an invocation  is
<span id="L753" class="LineNr">753 </span>     aborted.
<span id="L754" class="LineNr">754 </span>
<span id="L755" class="LineNr">755 </span>
<span id="L756" class="LineNr">756 </span>Syntax:
<span id="L757" class="LineNr">757 </span>  dcl ocu_$release entry <span class="textRainbow_lv2_p0">(</span>ptr<span class="textRainbow_lv2_p0">)</span>;
<span id="L758" class="LineNr">758 </span>  call ocu_$release <span class="textRainbow_lv2_p0">(</span>ocu_datap<span class="textRainbow_lv2_p0">)</span>;
<span id="L759" class="LineNr">759 </span>
<span id="L760" class="LineNr">760 </span>
<span id="L761" class="LineNr">761 </span>Arguments:
<span id="L762" class="LineNr">762 </span>
<span id="L763" class="LineNr">763 </span>ocu_datap
<span id="L764" class="LineNr">764 </span>     is a pointer returned by ocu_$open.  This identifies all the
<span id="L765" class="LineNr">765 </span>     data structures to be released.  <span class="textRainbow_lv2_p0">(</span>Input<span class="textRainbow_lv2_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
